'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _default9 = _interopDefault(require('ramda/src/path'));
var _default5 = _interopDefault(require('ramda/src/map'));
var _default15 = _interopDefault(require('ramda/src/partial'));
var _default14 = _interopDefault(require('ramda/src/over'));
var _default13 = _interopDefault(require('ramda/src/forEachObjIndexed'));
var _default12 = _interopDefault(require('ramda/src/view'));
var _default11 = _interopDefault(require('ramda/src/last'));
var _default10 = _interopDefault(require('ramda/src/has'));
var _default8 = _interopDefault(require('ramda/src/init'));
var _default7 = _interopDefault(require('ramda/src/complement'));
var _default6 = _interopDefault(require('ramda/src/lensPath'));
var _default4 = _interopDefault(require('ramda/src/isEmpty'));
var _default3 = _interopDefault(require('ramda/src/reject'));
var _default2 = _interopDefault(require('ramda/src/split'));
var _default = _interopDefault(require('ramda/src/pipe'));
var invariant = _interopDefault(require('invariant'));

var paths = (function (ps, obj) {
  return _default5(function (path) {
    return _default9(path, obj);
  }, ps);
});

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var toPath = _default(_default2(/[^\w\d]+/g), _default3(_default4));

var edgeToTransformation = function edgeToTransformation(_ref) {
  var _ref2 = slicedToArray(_ref, 2),
      fRawPath = _ref2[0],
      depRawPaths = _ref2[1];

  var fPath = toPath(fRawPath);
  var depPaths = _default5(toPath, depRawPaths);
  var fLens = _default6(fPath);

  return function (graph) {
    // Start of debug
    if (process.env.NODE_ENV !== 'production') {
      // Util functions we will need but only in non-prod
      var isPopulated = _default7(_default4);
      var isDependencyInGraph = function isDependencyInGraph(depPath, graph) {
        return _default(_default8, function (x) {
          return _default9(x)(graph);
        }, _default10(_default11(depPath)))(depPath);
      };

      // Check that the key exists for the func
      invariant(typeof _default12(fLens)(graph) === 'function', 'Function [' + fRawPath + '] not found in graph');

      // Check that the dep exists
      // It is important to note that a dep could be
      // null or undefined. Therefore we need to check the key
      // not the value
      _default13(function (depPath, idx) {
        invariant(isPopulated(depPath), 'Empty path at index [' + idx + '] for [' + fRawPath + ']');

        invariant(isDependencyInGraph(depPath, graph), 'Dependency [' + depRawPaths[idx] + '] for [' + fRawPath + '] not found in graph');
      })(depPaths);
    }
    // End of debug
    return _default14(fLens, function (f) {
      return _default15(f, paths(depPaths, graph));
    }, graph);
  };
};

var mapEdgesToTransformations = _default5(edgeToTransformation);

var index = (function (edges, graph) {
  var transformations = mapEdgesToTransformations(edges);

  return _default.apply(null, transformations)(graph);
});

module.exports = index;
