import _default9 from 'ramda/src/path';
import _default5 from 'ramda/src/map';
import _default15 from 'ramda/src/partial';
import _default14 from 'ramda/src/over';
import _default13 from 'ramda/src/forEachObjIndexed';
import _default12 from 'ramda/src/view';
import _default11 from 'ramda/src/last';
import _default10 from 'ramda/src/has';
import _default8 from 'ramda/src/init';
import _default7 from 'ramda/src/complement';
import _default6 from 'ramda/src/lensPath';
import _default4 from 'ramda/src/isEmpty';
import _default3 from 'ramda/src/reject';
import _default2 from 'ramda/src/split';
import _default from 'ramda/src/pipe';
import invariant from 'invariant';

var paths = (function (ps, obj) {
  return _default5(function (path) {
    return _default9(path, obj);
  }, ps);
});

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var toPath = _default(_default2(/[^\w\d]+/g), _default3(_default4));

var edgeToTransformation = function edgeToTransformation(_ref) {
  var _ref2 = slicedToArray(_ref, 2),
      fRawPath = _ref2[0],
      depRawPaths = _ref2[1];

  var fPath = toPath(fRawPath);
  var depPaths = _default5(toPath, depRawPaths);
  var fLens = _default6(fPath);

  return function (graph) {
    // Start of debug
    if (process.env.NODE_ENV !== 'production') {
      // Util functions we will need but only in non-prod
      var isPopulated = _default7(_default4);
      var isDependencyInGraph = function isDependencyInGraph(depPath, graph) {
        return _default(_default8, function (x) {
          return _default9(x)(graph);
        }, _default10(_default11(depPath)))(depPath);
      };

      // Check that the key exists for the func
      invariant(typeof _default12(fLens)(graph) === 'function', 'Function [' + fRawPath + '] not found in graph');

      // Check that the dep exists
      // It is important to note that a dep could be
      // null or undefined. Therefore we need to check the key
      // not the value
      _default13(function (depPath, idx) {
        invariant(isPopulated(depPath), 'Empty path at index [' + idx + '] for [' + fRawPath + ']');

        invariant(isDependencyInGraph(depPath, graph), 'Dependency [' + depRawPaths[idx] + '] for [' + fRawPath + '] not found in graph');
      })(depPaths);
    }
    // End of debug
    return _default14(fLens, function (f) {
      return _default15(f, paths(depPaths, graph));
    }, graph);
  };
};

var mapEdgesToTransformations = _default5(edgeToTransformation);

var index = (function (edges, graph) {
  var transformations = mapEdgesToTransformations(edges);

  return _default.apply(null, transformations)(graph);
});

export default index;
